<template>
  <i-wrapper top>
    <img src="~assets/images/circles-white.svg" class="circles circles--topBack" />
    <img src="~assets/images/stars-white.svg" class="stars" />
    <i-curtain>
      <nuxt-link :to="localePath({ name: 'index' })"></nuxt-link>
      <img src="~assets/images/figures-colored.svg" class="figures-colored" />
      <img src="~assets/images/scientist-circle.png" class="scientist-circle" />
      <div class="title text-center px-1">{{ $t(`Let's create your account!`) }}</div>
      <div class="normal-text text-center px-1">
        {{ $t(`You can continue with Google or enter your email address.`) }}
      </div>
      <template #bottom>
        <i-button
          block
          white
          bordered
          :icon="require(`~/assets/images/google.svg`)"
          @click="loginThroughGoogle()"
          :loading="isLoading === 'google'"
          :disabled="isLoading === 'google'">
          <span>{{ $t(`Continue with Google`) }}</span>
        </i-button>
        <div class="p-separator">
          <span />
          <span>ИЛИ</span>
          <span />
        </div>
        <form @submit.prevent="login()" class="p-form">
          <i-input
            ref="emailInput"
            v-model="user.email"
            type="email"
            placeholder="Enter your email"
            class="p-email-input"
            :loading="auth.emailChecker.isLoading" />
          <i-input
            ref="passwordInput"
            v-model="user.password"
            type="password"
            placeholder="Enter your password"
            class="p-password-input"
            :class="{ 'p-password-input--hidden': !auth.email || !auth.email.user || !auth.email.user.hasPassword }" />
          <i-button block submit :loading="isLoading === 'email'" :disabled="isLoading === 'email'">{{
            $t(`CONTINUE`)
          }}</i-button>
        </form>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  import { mapState, mapGetters } from 'vuex';

  export default {
    middleware: ['not-logged-in-only'],

    data() {
      return {
        user: {
          email:
            this.$store.state.auth.email &&
            (!this.$store.state.auth.email.user || this.$store.state.auth.email.user.authMethod === 'EMAIL')
              ? this.$store.state.auth.email.value
              : null,
          password: null,
        },
        rememberMe: true,
        isLoading: null,
      };
    },

    computed: {
      ...mapState(['auth']),
      ...mapGetters(['onboardingRoute']),
    },

    watch: {
      async 'user.email'(value) {
        await this.onUserEmailChange(value);
      },
    },

    mounted() {
      this.$nextTick(() => {
        this.$refs.emailInput.$refs.input.focus();
      });
    },

    methods: {
      async loginThroughGoogle() {
        if (this.isLoading) {
          return;
        }

        this.isLoading = 'google';

        try {
          let googleAuthCode = await this.$gAuth.getAuthCode();
          console.log('googleAuthCode', googleAuthCode);

          await this.$store.dispatch('loginThroughGoogle', {
            code: googleAuthCode,
            user: { utcOffset: this.$moment().utcOffset() },
            rememberMe: true,
          });

          fbq('track', 'CompleteRegistration');
          ga('send', 'event', this.auth.isNew ? 'sign_up' : 'login'); // , { method: 'Google' });

          await this.$router.push(
            this.onboardingRoute ? this.localePath({ name: this.onboardingRoute }) : { name: 'today' }
          );
        } catch (error) {
          this.isLoading = null;

          if (error.response && error.response.data.error === 'Bad Request') {
            alert(this.$t(error.response.data.message));
            return;
          }

          if (error.error === 'popup_closed_by_user') {
            return;
          }

          throw error;
        }
      },

      async onUserEmailChange() {
        clearTimeout(this.emailTimeout);
        this.isEmailChecking = true;

        this.emailTimeout = setTimeout(async () => {
          try {
            this.checkEmail();
          } catch (error) {
            console.error(error);
          }
        }, 250);
      },

      async onUserEmailChange(emailValue) {
        if (emailValue) {
          await this.$store.dispatch('checkEmail', emailValue);
        } else {
          await this.$store.dispatch('forgetEmail');
          this.invalidFields = {};
        }
      },

      async login() {
        if (!this.auth.email) {
          return this.$refs.emailInput.$refs.input.focus();
        }

        if (this.auth.emailChecker.isLoading) {
          return;
        }

        if (this.auth.email.user && this.auth.email.user.authMethod === 'GOOGLE') {
          return await this.loginThroughGoogle();
        }

        this.isLoading = 'email';

        try {
          if (this.auth.email.user) {
            await this.$store.dispatch('login', {
              user: this.user,
              rememberMe: this.rememberMe,
            });

            ga('send', 'event', 'login'); // , { method: 'Email' });
          } else {
            await this.$store.dispatch('register', {
              user: {
                email: this.user.email,
                password:
                  !this.auth.email || !this.auth.email.user || !this.auth.email.user.hasPassword
                    ? null
                    : this.user.password,
                utcOffset: this.$moment().utcOffset(),
              },
              rememberMe: this.rememberMe,
            });

            fbq('track', 'CompleteRegistration');
            ga('send', 'event', 'sign_up'); // , { method: 'Email' });
          }

          await this.$router.push(
            this.onboardingRoute ? this.localePath({ name: this.onboardingRoute }) : { name: 'today' }
          );
        } catch (error) {
          this.isLoading = null;

          if (error.response && error.response.data.error === 'Validation') {
            let firstErrorMessageKey = Object.keys(error.response.data.invalidFields)[0];
            let firstErrorMessageText = error.response.data.invalidFields[firstErrorMessageKey][0];
            alert(this.$t(firstErrorMessageText));

            if (firstErrorMessageText === 'The password field is required.') {
              this.$refs.passwordInput.$refs.input.focus();
            } else if (firstErrorMessageText === 'The provided password is incorrect.') {
              this.$refs.passwordInput.$refs.input.focus();
            }

            return;
          }

          throw error;
        }
      },
    },
  };
</script>

<style lang="scss" scoped>
  .figures-colored {
    position: absolute;
    z-index: 0;
    top: rs(30px);
    right: rs(7px);
    width: rw(360px);
  }

  .scientist-circle {
    width: rw(128px);
    margin-top: rs(35px);
  }

  .title {
    font-weight: bold;
    font-size: rf(20px);
    margin-top: rs(15px);
  }

  .p-separator {
    position: relative;
    display: flex;
    width: 100%;
    height: rs(20px);
    justify-content: center;
    align-items: center;
    margin: rs(25px) 0;
    padding: 0 rs(20px);

    span:first-child,
    span:last-child {
      display: block;
      height: rs(1px);
      flex-grow: 1;
      background-color: #bdbdbd;
    }

    span:nth-child(2) {
      margin-left: rs(5px);
      margin-right: rs(5px);
      color: #bdbdbd;
    }
  }

  .p-email-input {
    margin-bottom: rs(16px);
  }

  .p-password-input {
    margin-bottom: rs(16px);
    opacity: 1;
    transition: opacity 0.2s, height 0.2s, margin-bottom 0.2s;

    &--hidden {
      opacity: 0;
      height: 0;
      margin-bottom: 0;
    }
  }

  .p-form {
    width: 100%;
  }
</style>
